

module IO

  INTERFACE writebuff
     MODULE PROCEDURE writebuff_m,writebuff_v
  end INTERFACE
  
CONTAINS
 
  function readbuff(filename,n) result(A)
    use matrix
    use kind
    IMPLICIT NONE
    INTEGER :: n 
    REAL(kn), DIMENSION(n) :: A
    CHARACTER(len = *), INTENT(IN) :: filename  ! using assumed-length specifier
    REAL(kn) :: value
    INTEGER :: index, status
    
    OPEN (UNIT = 3, FILE = filename, ACTION = 'READ')
    
    index = 1
    
    readloop: DO
       READ (3,*,IOSTAT=status) value
       IF (status /= 0) EXIT
       A(index) = value
       index = index + 1
    end DO readloop

    CLOSE (UNIT = 3)
    
  end function readbuff



  SUBROUTINE writebuff_m(filename,A)
    use matrix
    use kind
    IMPLICIT NONE
    REAL(kn), DIMENSION(:,:) :: A
    CHARACTER(len = *), INTENT(IN) :: filename  ! using assumed-length specifier
    INTEGER :: i,j,status
    
    OPEN (UNIT = 3, FILE = filename, ACTION = 'WRITE')

    DO i = 1, size(A,1)
       WRITE(3,*) (A(i,j),j=1,size(A,2))
    end DO

    CLOSE (UNIT = 3)
    
  end SUBROUTINE writebuff_m




  SUBROUTINE writebuff_v(filename,A)
    use matrix
    use kind
    IMPLICIT NONE
    REAL(kn), DIMENSION(:) :: A
    CHARACTER(len = *), INTENT(IN) :: filename  ! using assumed-length specifier
    INTEGER :: i,j,status
    
    OPEN (UNIT = 3, FILE = filename, ACTION = 'WRITE')

    DO i = 1, size(A,1)
       WRITE(3,*) A(i)
    end DO

    CLOSE (UNIT = 3)
    
  end SUBROUTINE writebuff_v






end module IO
